/*******************************************************************************
 *	BDir.h		BEAM Dir access class
 *			T.Barnaby,	BEAM Ltd,	8/10/96
 *******************************************************************************
 */
#ifndef BDIR_H
#define BDIR_H	1

#include	<BList.h>
#include	<BString.h>
#include	<BError.h>
#include	<sys/stat.h>

/// File system directory class. 
class BDir : public BList<struct dirent*> {
public:
			BDir();
			BDir(BString name);
			~BDir();

	BError		open(BString name);		///< Reads named directory 
	BError		error();			///< Current value of error
	BError		read();				///< read/re-reads directory 
	void		clear();			///< Clears list

	void		setWild(BString wild);		///< Set wildcard filter string used on read
	void		setSort(int on);		///< Set alpha sort on/off

	BString		entryName(BIter i);		///< Get filename
	struct stat	entryStat(BIter i);		///< Get file stats
	struct stat64	entryStat64(BIter i);		///< Get file stats 64

private:
	BError		oerror;
	BString		odirname;
	BString		owild;
	int		osort;
};

#endif
